# coding: utf-8

"""
    CredentialIssuanceService

    Affinidi Credential Issuance Service Structure

    The version of the OpenAPI document: 1.0.0
    Contact: info@affinidi.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr, validator

class CredentialProof(BaseModel):
    """
    Object containing the proof of possession of the cryptographic key material the issued Credential would be bound to.  # noqa: E501
    """
    proof_type: StrictStr = Field(..., description="String denoting the key proof type.")
    jwt: StrictStr = Field(...)
    __properties = ["proof_type", "jwt"]

    @validator('proof_type')
    def proof_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('jwt'):
            raise ValueError("must be one of enum values ('jwt')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CredentialProof:
        """Create an instance of CredentialProof from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CredentialProof:
        """Create an instance of CredentialProof from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CredentialProof.parse_obj(obj)

        _obj = CredentialProof.parse_obj({
            "proof_type": obj.get("proof_type"),
            "jwt": obj.get("jwt")
        })
        return _obj


