# coding: utf-8

"""
    CredentialIssuanceService

    Affinidi Credential Issuance Service Structure

    The version of the OpenAPI document: 1.0.0
    Contact: info@affinidi.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class CredentialResponseDeferred(BaseModel):
    """
    CredentialResponseDeferred
    """
    transaction_id: StrictStr = Field(..., description="String identifying a Deferred Issuance transaction. This claim is contained in the response if the Credential Issuer was unable to immediately issue the Credential.")
    c_nonce: StrictStr = Field(..., description="String containing a nonce to be used when creating a proof of possession of the key proof")
    c_nonce_expires_in: Union[StrictFloat, StrictInt] = Field(..., description="Lifetime in seconds of the c_nonce")
    __properties = ["transaction_id", "c_nonce", "c_nonce_expires_in"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CredentialResponseDeferred:
        """Create an instance of CredentialResponseDeferred from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CredentialResponseDeferred:
        """Create an instance of CredentialResponseDeferred from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CredentialResponseDeferred.parse_obj(obj)

        _obj = CredentialResponseDeferred.parse_obj({
            "transaction_id": obj.get("transaction_id"),
            "c_nonce": obj.get("c_nonce"),
            "c_nonce_expires_in": obj.get("c_nonce_expires_in")
        })
        return _obj


